scripts/borg-backup.theseus.sh

97 lines
2.8 KiB
Bash
Raw Normal View History

2023-06-11 00:09:02 +02:00
#!/usr/bin/env bash
2023-06-11 17:01:35 +02:00
# run as root
export euid=$(id -u)
if [ ${euid} -eq 0 ]; then
echo "Running as root"
else
echo "This script should be run as root"
exit
fi
2023-06-11 00:09:02 +02:00
# check if password was set
if [[ -z "${BORG_PASSPHRASE}" ]]; then
echo 'BORG_PASSPHRASE is not set, `export BORG_PASSPHRASE=PASS`'
2023-06-11 17:01:35 +02:00
exit
2023-06-11 00:09:02 +02:00
fi
2023-06-11 17:01:35 +02:00
export REMOTE_USER=fileserver@homeserver.box
export REMOTE_PATH=/srv/data/backup/borg/theseus
export BORG_REPO=$REMOTE_USER:$REMOTE_PATH
export BORG_BIN="$(which borg)"
2023-06-11 00:09:02 +02:00
# some helpers and error handling:
info() { printf "\n%s %s\n\n" "$( date )" "$*" >&2; }
trap 'echo $( date ) Backup interrupted >&2; exit 2' INT TERM
2023-06-11 17:01:35 +02:00
echo "Starting backup"
2023-06-11 00:09:02 +02:00
# Backup the most important directories into an archive named after
# the machine this script is currently running on:
$BORG_BIN create \
2023-06-11 00:09:02 +02:00
--verbose \
--filter AME \
--list \
--stats \
--show-rc \
--compression zstd,11 \
--exclude-caches \
--exclude 'home/*/.cache/*' \
2023-06-11 17:01:35 +02:00
--exclude 'home/*/Documents/code/compile/*' \
--exclude '*Cache*' \
--exclude 'home/*/Download/*' \
--exclude 'home/*/.local/*' \
--exclude '*JetBrains/Toolbox/apps*' \
2023-06-11 00:09:02 +02:00
--exclude '*/.Trash*' \
2023-06-11 01:49:00 +02:00
--exclude '*/Trash*' \
2023-06-11 17:01:35 +02:00
--exclude '*/build/*' \
--exclude '*/target/*' \
2023-06-11 17:01:35 +02:00
--exclude '*Steam*' \
2023-06-11 00:09:02 +02:00
\
2023-06-11 01:49:00 +02:00
${BORG_REPO}::'{hostname}-{now}' \
2023-06-11 00:09:02 +02:00
/home \
2023-06-11 17:01:35 +02:00
/root \
/etc
2023-06-11 00:09:02 +02:00
backup_exit=$?
2023-06-11 17:01:35 +02:00
echo "Pruning repository"
2023-06-11 00:09:02 +02:00
# Use the `prune` subcommand to maintain 3 daily, 3 weekly and 6 monthly
# archives of THIS machine. The '{hostname}-*' matching is very important to
# limit prune's operation to this machine's archives and not apply to
# other machines' archives also:
$BORG_BIN prune \
2023-06-11 00:09:02 +02:00
--list \
--glob-archives '{hostname}-*' \
--show-rc \
--keep-daily 3 \
--keep-weekly 3 \
--keep-monthly 6
prune_exit=$?
# actually free repo disk space by compacting segments
2023-06-11 17:01:35 +02:00
echo "Compacting repository"
2023-06-11 00:09:02 +02:00
$BORG_BIN compact
2023-06-11 00:09:02 +02:00
compact_exit=$?
# use highest exit code as global exit code
global_exit=$(( backup_exit > prune_exit ? backup_exit : prune_exit ))
global_exit=$(( compact_exit > global_exit ? compact_exit : global_exit ))
if [ ${global_exit} -eq 0 ]; then
2023-06-11 17:01:35 +02:00
echo "Backup, Prune, and Compact finished successfully"
2023-06-11 00:09:02 +02:00
elif [ ${global_exit} -eq 1 ]; then
2023-06-11 17:01:35 +02:00
echo "Backup, Prune, and/or Compact finished with warnings"
2023-06-11 00:09:02 +02:00
else
2023-06-11 17:01:35 +02:00
echo "Backup, Prune, and/or Compact finished with errors"
2023-06-11 00:09:02 +02:00
fi
2023-06-11 17:01:35 +02:00
ssh $REMOTE_USER du -hs $REMOTE_PATH
2023-06-11 00:09:02 +02:00
exit ${global_exit}